#ifdef FEEDBACK

#include <GL/glut.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#ifdef FEEDBACK
extern void display( void );
#endif

#define WAIT //  {char _str[81];fprintf(stderr,"...");fgets(_str,80,stdin);}

#define FALSE (0)
#define TRUE  (1)
#define ROUND(f)	(f>0 ? (int)(f+0.5) : (int)(f-0.5))

typedef struct rgba_ {
        GLfloat r, g, b, a;
        } rgba;

#define BUFSIZE (200000)
//#define BUFSIZE (100)
//#define BUFSIZE (1024)
static GLfloat *feedBuffer=NULL;
static char epsfilename[] = "out.eps";
static FILE *eps = NULL;
static rgba *colTab = NULL;
static int numcol;
static int vcount, *colindx = NULL;
static GLsizei size3Dcol, j;
static GLsizei llx = 0, lly = 0, urx = 500, ury = 500;
static GLfloat minx, maxx, miny, maxy;


static void setLight() {
  GLfloat light_ambient[] = { 0.0, 0.0, 0.0, 1.0 };
  GLfloat light_diffuse[] = { 0.0, 0.0, 1.0, 1.0 };
  GLfloat light_specular[] = { 0.0, 0.0, 1.0, 1.0 };
  GLfloat light_position[] = { 2.0, 2.0, -2.0, 0.0 };

  GLfloat light1_ambient[] = { 0.0, 0.0, 0.0, 1.0 };
  GLfloat light1_diffuse[] = { 1.0, 0.0, 0.0, 1.0 };
  GLfloat light1_specular[] = { 1.0, 0.0, 0.0, 1.0 };
  GLfloat light1_position[] = { -2.0, -2.0, -2.0, 0.0 };

  GLfloat light2_ambient[] = { 0.2, 0.2, 0.2, 1.0 };
  GLfloat light2_diffuse[] = { 1.0, 0.0, 0.0, 1.0 };
  GLfloat light2_specular[] = { 1.0, 0.0, 0.0, 1.0 };
  GLfloat light2_position[] = { 0.0, 0.0, 5.0, 0.0 };
  GLfloat spot_direction[] = { -1.0, -1.0, -1.0 };

  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);

  glLightfv(GL_LIGHT1, GL_AMBIENT, light1_ambient);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
  glLightfv(GL_LIGHT1, GL_SPECULAR, light1_specular);
  glLightfv(GL_LIGHT1, GL_POSITION, light1_position);

  glLightfv(GL_LIGHT2, GL_AMBIENT, light2_ambient);
  glLightfv(GL_LIGHT2, GL_DIFFUSE, light2_diffuse);
  glLightfv(GL_LIGHT2, GL_SPECULAR, light2_specular);
  glLightfv(GL_LIGHT2, GL_POSITION, light2_position);
  glLightf(GL_LIGHT2, GL_CONSTANT_ATTENUATION, 0.5);
  glLightf(GL_LIGHT2, GL_LINEAR_ATTENUATION, 0.1);
  glLightf(GL_LIGHT2, GL_QUADRATIC_ATTENUATION, 0.1);
  glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, 45.0);
  glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, spot_direction);
  glLightf(GL_LIGHT2, GL_SPOT_EXPONENT, 2.0);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHT1);
  glEnable(GL_LIGHT2);
}


void initEpsdriver(void)
{
  size3Dcol = (GLsizei) ( BUFSIZE * (7+1) );
  feedBuffer = (GLfloat*) malloc(sizeof(GLfloat)*(size_t)size3Dcol);
  if( feedBuffer==NULL ) { fprintf(stderr,"No memory. Exitus...\n");exit(1);}
  printf("Cleaning buffer of size %d ...\n", size3Dcol );
  for( j=0; j<size3Dcol; j++ ) feedBuffer[j] = 0.0;
  printf("Cleaned buffer.\n");

  colTab = (rgba*) malloc(sizeof(struct rgba_) * BUFSIZE);
  if( colTab==NULL ) { fprintf(stderr,"No memory. Exitus...\n");exit(1);}
  colindx = (int*) malloc(sizeof(int) * BUFSIZE);
  if( colindx==NULL ) { fprintf(stderr,"No memory. Exitus...\n");exit(1);}

  //setLight();

  glClearColor (0.0, 0.0, 0.0, 0.0);
}


void freebuffers(void)
{
  free( feedBuffer );
  free( colTab ); free( colindx );
}


void initdocu(void)
{
  eps = fopen( epsfilename, "w" );
  if( eps == NULL )
    { fprintf(stderr,"Cannot open '%s'!...\n", epsfilename ); exit(1); }
}


void closedocu(void)
{
  fprintf( eps,"%%%%\nshowpage\n" );
  fclose( eps );
}

#ifndef FEEDBACK
void display() {
  glRotatef( 20.0, 1.0, 1.0, 1.0 );
//  glBegin (GL_QUADS);
  glBegin (GL_LINE_LOOP);
    glVertex3f (-0.5, -0.5, 0.0);
    glVertex3f (-0.5, 0.5, 0.0);
    glVertex3f (0.5, 0.5, 0.0);
    glVertex3f (0.5, -0.5, 0.0);
  glEnd ();
  return;

//  glutSolidTeapot(1.0);
//  glutWireTeapot(1.0);
  glutWireCone(1.0, 2.0, 10, 5);
//  glutSolidCone(1.0, 2.0, 10, 5);
  glutSwapBuffers();
}
#endif

void drawGeometry (GLenum mode)
{
  if (mode == GL_FEEDBACK)
    glPassThrough (1.0);

  glBegin (GL_POINTS);
    glVertex3f (35.0, 35.0, 0.0); /* will be clipped */
  glEnd ();

  if (mode == GL_FEEDBACK)
    glPassThrough (2.0);

/**/
//  glPolygonMode( GL_FRONT, GL_LINE );
  glPolygonMode( GL_FRONT, GL_FILL );
  glBegin (GL_POLYGON);
    glVertex3f (35.0, 35.0, 0.0);
    glVertex3f (55.0, 35.0, 3.0);
    glVertex3f (55.0, 55.0, 4.0);
    glVertex3f (40.0, 65.0, 5.0);
    glVertex3f (35.0, 55.0, 6.0);
  glEnd ();	/**/
  //return;

  if (mode == GL_FEEDBACK)
    glPassThrough (3.0);

  glBegin (GL_LINE_STRIP);
    glNormal3f (0.0, 0.0, 1.0);
    glVertex3f (30.0, 30.0, 0.0);
    glVertex3f (50.0, 60.0, 5.0);
    glVertex3f (70.0, 40.0, 10.0);
  glEnd ();

  if (mode == GL_FEEDBACK)
    glPassThrough (4.0);

  glBegin (GL_POINTS);
    glVertex3f (-100.0, -100.0, -100.0); /* will be clipped */
  glEnd ();

  if (mode == GL_FEEDBACK)
    glPassThrough (5.0);

  glBegin (GL_POINTS);
    glNormal3f (0.0, 0.0, 1.0);
    glVertex3f (50.0, 50.0, 5.0);
  glEnd ();

  if (mode == GL_FEEDBACK)
    glPassThrough (5.0);

  glMatrixMode (GL_MODELVIEW);
  glPushMatrix();
  glTranslatef( 25.0, 20.0, 0.0);
  glRotatef( 15.0, 1.0, 1.0, 1.0 );
//  glutWireTeapot(1.0);
//  glutSolidTeapot(1.0);
  glutWireCone(5.0, 2.0, 10, 5);
//  glutWireCube( 10.0 );
  glPopMatrix();

  if (mode == GL_FEEDBACK)
    glPassThrough (6.0);
  glutSwapBuffers();
}

static GLfloat lastx=-1.0, lasty=-1.0;
static GLint startToken = FALSE;


static void checkColor(GLfloat r, GLfloat g, GLfloat b, GLfloat a)
{
  GLint found = FALSE;
  int c = 0;

  // Check if the RGB value already exists, if not create a new color entry
  while( ! found && c < numcol ) {
    found = r == colTab[c].r &&  g == colTab[c].g &&
	 b == colTab[c].b && a == colTab[c].a;
    if( ! found )
      c++;
  }
  if( ! found ) {
    colTab[numcol].r = r; colTab[numcol].g = g;
    colTab[numcol].b = b; colTab[numcol].a = a;
    numcol++;
    // avoid compiler warning:
    {GLfloat dummy; dummy=a;}
  }
  colindx[vcount] = c;
}

static void analyzeColor (GLint *count, GLfloat *buffer)
{
  GLfloat x, y, z, r, g, b, a;

  x = buffer[(*count)];
  y = buffer[(*count)+1];
  z = buffer[(*count)+2];
  r = buffer[(*count)+3];
  g = buffer[(*count)+4];
  b = buffer[(*count)+5];
  a = buffer[(*count)+6];
  /* printf("(x,y,z,r,g,b,a)=(%.2f,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f)\n",
	x,y,z,r,g,b,a );	/**/
  checkColor( r, g, b, a );
}


#define BB	1
#define COL	2
#define VRTX	3
static GLenum action;

static GLfloat posx, posy;
static int lastc;	// last painted color
static int newVertex;	// new x-y vertex in buffer

static void parseVertex( GLenum action,
				GLint *count, GLfloat *buffer) {
  GLfloat x, y, z, r, g, b, a;

  x = buffer[*count]; y = buffer[(*count)+1]; z = buffer[(*count)+2];
  r = buffer[(*count)+3]; g = buffer[(*count)+4];
  b = buffer[(*count)+5]; a = buffer[(*count)+6];

  switch (action) {
    case BB:
      if( x < minx ) minx = x; if( y < miny ) miny = y;
      if( x > maxx ) maxx = x; if( y > maxy ) maxy = y;
      break;
    case COL:
      analyzeColor ( count, buffer );
      break;
    case VRTX:
      /* if( vcount == 0 ) {
        fprintf( eps, "%%\%%\t Initializing color\n" );
        fprintf( eps, "%.3f %.3f %.3f setrgbcolor\n%%\n",
			colTab[0].r, colTab[0].r, colTab[0].r );
        lastc = 0;
      } /**/
      newVertex = x!=lastx || y!=lasty  || startToken;
      if( newVertex ) {
        /*fprintf(stderr," >>startT=%d (x,y)=(%.6f,%.6f) (lx,ly)=(%.6f,%.6f)\n",
					startToken, x, y, lastx, lasty );/**/
        posx = x; posy = y;
        lastx = x; lasty = y;
      }
      startToken = FALSE;
      break;
    default:
      fprintf(stderr,"Action not defined. Exitus.\n" ); exit(1);
  }
  *count = *count + 7;
  vcount++;
}

static int isToken( GLfloat buffElem ) {
  return(
	buffElem == GL_PASS_THROUGH_TOKEN ||
	buffElem == GL_POINT_TOKEN ||
	buffElem == GL_LINE_TOKEN ||
	buffElem == GL_LINE_RESET_TOKEN ||
	buffElem == GL_BITMAP_TOKEN ||
	buffElem == GL_DRAW_PIXEL_TOKEN ||
	buffElem == GL_COPY_PIXEL_TOKEN );
}

void changeCol() {
  GLint c;

  c = colindx[vcount];
  if( c != lastc && c < BUFSIZE && c > 0 )	/* Thiago  1 */
    /* fprintf(eps,"%% Color index of vertex %d = %d , lastc=%d\n",
				vcount, c, lastc ); /**/
    fprintf(eps,"%.3f %.3f %.3f setrgbcolor\n",
			colTab[c].r, colTab[c].g, colTab[c].b );
  lastc = c;
}

void putLastColWithoutCmd() {
  GLint c;

  c = colindx[vcount];
  fprintf(eps,"%.3f %.3f %.3f ", colTab[c].r, colTab[c].g, colTab[c].b );
}

void parseBuffer( GLenum action, GLint size, GLfloat *buffer )
{
  GLint count, numpolypoints;
  GLfloat token;

  count = 0; vcount = 0;
  while (count < size) {
    token = buffer[count]; count++;
    switch ((int)token) {
      case (int)GL_PASS_THROUGH_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_PASS_THROUGH_TOKEN\n",count-1,token);
        count++;
        break;
      case (int)GL_POINT_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_POINT_TOKEN\n",count-1,token);
        parseVertex(action,&count, buffer);
        if( action == VRTX ) {
          fprintf(eps,"%.4f %.4f dot1\n", posx, posy );
          changeCol();
        }
        break;
      case (int)GL_LINE_RESET_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_LINE_RESET_TOKEN\n",count-1,token);
        if( action == VRTX ) fprintf(eps,"\nnewpath %% Line Reset at %d\n",
		count-1);
        parseVertex(action,&count, buffer);
        if( action == VRTX ) {
          changeCol();
          fprintf(eps,"%.4f %.4f moveto\n", posx, posy );
        }
        parseVertex(action,&count, buffer);
        if( action == VRTX ){
			if( newVertex) {
				fprintf(eps,"%.4f %.4f lineto\n", posx, posy );
			}
			/* Thiago 1 */
			if( buffer[count] != GL_LINE_TOKEN )
				fprintf(eps,"stroke\n\n" );
			if( newVertex) {
				changeCol();
			}
		}
        break;
      case (int)GL_LINE_TOKEN:
        //printf("count=%4d token=%.0f=GL_LINE_TOKEN\n",count-1,token);
        parseVertex(action,&count, buffer);
        if( action == VRTX )
          if( newVertex) {
            changeCol();
            fprintf(eps,"%.4f %.4f lineto\n", posx, posy );
          }
        parseVertex(action,&count, buffer);
        if( action == VRTX ){
          if( newVertex) {
            fprintf(eps,"%.4f %.4f lineto\n", posx, posy );
          }
          if( buffer[count] != GL_LINE_TOKEN )
            fprintf(eps,"stroke\n\n" );
          if( newVertex) {
            changeCol();
          }
		}
		break;
      case (int)GL_POLYGON_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_POLYGON_TOKEN\n",count-1,token);
        numpolypoints = (GLint)buffer[count]; count++;
        if( action == VRTX  && numpolypoints != 3) {
          fprintf(eps,"newpath %% Polygon at %d\n", count-1 );
        }
        for( j = 0; j < numpolypoints; j++ ) {
          parseVertex(action,&count, buffer);
          if( action == VRTX ) {
            fprintf(eps,"%.4f %.4f ", posx, posy );
            if( numpolypoints != 3 ) {
              if( j == 0 )
                fprintf(eps," moveto\n" );
              else
                fprintf(eps," lineto\n" );
	      }
          }
        }
        if( action == VRTX ) {
          if( numpolypoints == 3) {
            fprintf(eps," triangle\n");
            putLastColWithoutCmd();
            fprintf(eps," filltriangle\n");
          }
          else
            fprintf(eps,"closepath\nfill\n\n" );
        }
        break;
      case (int)GL_BITMAP_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_BITMAP_TOKEN\n",count-1,token);
        parseVertex(action,&count, buffer);
        break;
      case (int)GL_DRAW_PIXEL_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_DRAW_PIXEL_TOKEN\n",count-1,token);
        parseVertex(action,&count, buffer);
        break;
      case (int)GL_COPY_PIXEL_TOKEN:
        startToken = TRUE;
        //printf("count=%4d token=%.0f=GL_COPY_PIXEL_TOKEN\n",count-1,token);
        parseVertex(action,&count, buffer);
        break;
      default:
        fprintf(stderr,"Expected token at buffer position %d of %d=%f. Exit\n",
		count-1, size, buffer[count-1] ); exit(1);
    }
  }
}


static char epsprologue[] =
"/filltriangle {\n\
	setrgbcolor\n\
	fill\n\
} def\n\
\n\
/stroketriangle {\n\
	setrgbcolor\n\
	stroke\n\
} def\n\
\n\
/triangle {\n\
	newpath\n\
	moveto\n\
	lineto\n\
	lineto\n\
	closepath\n\
} def\n\
\n\
/dot {\n\
	newpath\n\
	2 div\n\
	0 360 arc\n\
	closepath\n\
	fill\n\
} def\n\
\n\
/dot1 {\n\
	newpath\n\
	0.5 0 360 arc\n\
	closepath\n\
	fill\n\
} def\n\
\n\
0.0001 setlinewidth\n\
1 setlinecap %% round shape\n\
0 setlinejoin %% miter line join\n\
\n";



static void peep( GLint size, GLfloat *buffer)  {
  int i;
  GLfloat token;

  // Peep colors
  printf("\nColor Table with %d RGBA colors:\n", numcol );
  for( i = 0; i < numcol; i++ ) {
    printf("Color %5d=(r,g,b,a)=(%.2f,%.2f,%.2f,%.2f)\n",
	i, colTab[i].r, colTab[i].g, colTab[i].b, colTab[i].a );	/**/
  }

  printf("\nColor index of the %d vertices:\n", vcount );
  for( i = 0; i < vcount; i++ ) {
    printf("col[%5d]=%5d\n", i, colindx[i] );	/**/
  }

  // Peep buffer
  for( i = 0; i < size; i++ ) {
    if( isToken( buffer[i] ) ) {
      token = buffer[i];
      switch ((int)token) {
        case (int)GL_PASS_THROUGH_TOKEN:
          printf("%% count=%4d token=%.0f=GL_PASS_THROUGH_TOKEN\n",i,token);
          break;
        case (int)GL_POINT_TOKEN:
          printf("%% count=%4d token=%.0f=GL_POINT_TOKEN\n",i,token);
          break;
        case (int)GL_LINE_RESET_TOKEN:
          printf("%% count=%4d token=%.0f=GL_LINE_RESET_TOKEN\n",i,token);
          break;
        case (int)GL_LINE_TOKEN:
          printf("%% count=%4d token=%.0f=GL_LINE_TOKEN\n",i,token);
          break;
        case (int)GL_POLYGON_TOKEN:
          printf("%% count=%4d token=%.0f=GL_POLYGON_TOKEN\n",i,token);
          break;
        case (int)GL_BITMAP_TOKEN:
          printf("%% count=%4d token=%.0f=GL_BITMAP_TOKEN\n",i,token);
          break;
        case (int)GL_DRAW_PIXEL_TOKEN:
          printf("%% count=%4d token=%.0f=GL_DRAW_PIXEL_TOKEN\n",i,token);
          break;
        case (int)GL_COPY_PIXEL_TOKEN:
          printf("%% count=%4d token=%.0f=GL_COPY_PIXEL_TOKEN\n",i,token);
          break;
        default:
          fprintf(stderr,"Error in 'peep'. Exit\n" ); exit(1);
      }
    }
    printf("%% %6d %10.2f\n", i, buffer[i] );
  }


  //for( i = 0; i < size; i++ ) fprintf(eps,"%% %6d %10.2f\n", i, buffer[i] );

}



void analyzeBuffer(GLint size, GLfloat *buffer)
{
  initdocu();
  action = BB;
  minx = 10000000000.0;
  maxx = -1.0;
  miny = 10000000000.0;
  maxy = -1.0;
  parseBuffer( action, size, buffer );
  printf("BB of vertex= %f %f %f %f\n", minx, miny, maxx, maxy );
  llx = ROUND(minx); if( llx > 0 ) llx--;
  lly = ROUND(miny); if( lly > 0 ) lly--;
  urx = 1+ROUND(maxx); ury = 1+ROUND(maxy);
  fprintf( eps,"%%!PS-Adobe-3.0 EPSF-3.0\n%%%%BoundingBox: %d %d %d %d\n",
		llx, lly, urx, ury );
  fprintf( eps,"\n%s", epsprologue );

  action = COL;
  numcol = 1;
  parseBuffer( action, size, buffer );
  fprintf( eps,
	"%%\n%%\tNumber of RGB colors found in feedback buffer = %d\n%%\n",
			numcol);

  action = VRTX; lastc = 0;
  parseBuffer( action, size, buffer );
  //peep( size, buffer );
  closedocu();
}



void specify_viewing_and_projection()
{
  /* Specify modelview matrix */
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.000000, 0.000000, 5.000000,
      0.000000, 0.000000, 0.000000,
      0.000000, 1.000000, 0.000000 );

  /* Specify projection matrix */
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  glFrustum( -1.500000, 1.500000, -1.500000, 1.500000, 3.000000, 6.500000);
//  glOrtho (-10.0, 10.0, -10.0, 10.0, -10.0, 10.0);

  glMatrixMode( GL_MODELVIEW );
}


void displayFeedback(void)
{
  GLint size;

  specify_viewing_and_projection();
  glClear(GL_COLOR_BUFFER_BIT);
  //drawGeometry (GL_RENDER);
  display();

  /* Draw scene now with feedback mode into feedback buffer */

  glFeedbackBuffer (size3Dcol, GL_3D_COLOR, feedBuffer);
  (void) glRenderMode (GL_FEEDBACK);
  //drawGeometry (GL_FEEDBACK);
  display();
  size = glRenderMode (GL_RENDER);
  if( size < 0 ) { fprintf(stderr,
	"Feedback buffer overflow. Increment buffer size of %d. Exitus...\n",
	BUFSIZE); exit(1);
  }
  printf("Number of feedback elements = %d...\n", size ); WAIT;
  analyzeBuffer (size, feedBuffer);
  fprintf(stderr,"Getting out...\n"); exit(0);	// get out imediately
}

void keyboard( unsigned char key, int x, int y ) 
{
  switch (key) {
    case 'q':
      fprintf(stderr,"Bye...\n" );
      exit(0);
      break;
    default:
      fprintf(stderr,"Key not defined\n" );
      // avoid compiler warning:
      {int dummy; dummy=x;dummy=y;}
  }
}



#ifndef FEEDBACK
int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize (300, 200);
  glutInitWindowPosition (100, 100);
  glutCreateWindow(argv[0]);
  initEpsdriver();
  glutDisplayFunc(displayFeedback);
  glutKeyboardFunc(keyboard);
  glutMainLoop();
  freebuffers();
  return 0;
}
#endif
#endif
