#include <glui.h>
#include <math.h>
#include "glutobj.h"
#include "mvproj.h"


float view_rotate[16] = { 1.0,0.0,0.0,0.0, 0.0,1.0,0.0,0.0,
				0.0,0.0,1.0,0.0, 0.0,0.0,0.0,1.0 };
int animation_x_z = 0;
int animation_x_y = 0;

int wireframe = (int)GL_TRUE, vvwireframe = (int)GL_FALSE;
int object_type = 3; // 0=Teapot 1=Cube 2=Sphere 3=Cone     

#define DELAY	(10)	/* Delay before calling timer callback (msec) */
unsigned int delay = DELAY;

#ifndef FEEDBACK
/*
 *    The GLUI Interface
*/

extern int main_window;

  
extern void Reset(int i);
extern void show_modelview_and_projection_matrices(int dummy);
extern void gen_c_code_viewing_and_proj( int i );
extern void update_mv1();


#define RESET   10000

GLUI_Spinner *spinner_centerx; 
GLUI_Spinner *spinner_centery; 
GLUI_Spinner *spinner_centerz; 
GLUI_Spinner *spinner_eyex; 
GLUI_Spinner *spinner_eyey;
GLUI_Spinner *spinner_eyez;
GLUI_Spinner *spinner_upx; 
GLUI_Spinner *spinner_upy;
GLUI_Spinner *spinner_upz;
GLUI_Spinner *spinner_near;
GLUI_Spinner *spinner_far; 
GLUI_Spinner *spinner_left; 
GLUI_Spinner *spinner_right; 
GLUI_Spinner *spinner_bottom; 
GLUI_Spinner *spinner_top;
GLUI_Spinner *spinner_fovy;
GLUI_Spinner *spinner_aspect;
GLUI_Checkbox *checkbox_animation_xz;   
GLUI_Checkbox *checkbox_animation_xy;
GLUI_Spinner *spinner_delay;
GLUI_Checkbox *checkbox_ortho;
GLUI_RadioGroup *group_frustum;
GLUI_RadioButton *radiogroup_perspective;
GLUI_RadioButton *radiogroup_frustum;

GLUI_Spinner *spinner_centerx2; 
GLUI_Spinner *spinner_centery2; 
GLUI_Spinner *spinner_centerz2; 
GLUI_Spinner *spinner_eyex2; 
GLUI_Spinner *spinner_eyey2;
GLUI_Spinner *spinner_eyez2;
GLUI_Spinner *spinner_upx2; 
GLUI_Spinner *spinner_upy2;
GLUI_Spinner *spinner_upz2;
GLUI_Spinner *spinner_near2;
GLUI_Spinner *spinner_far2; 
GLUI_Spinner *spinner_left2; 
GLUI_Spinner *spinner_right2; 
GLUI_Spinner *spinner_bottom2; 
GLUI_Spinner *spinner_top2;
GLUI_Spinner *spinner_fovy2;
GLUI_Spinner *spinner_aspect2;
GLUI_Checkbox *checkbox_ortho2;
GLUI_RadioGroup *group_frustum2;
GLUI_RadioButton *radiogroup_perspective2;
GLUI_RadioButton *radiogroup_frustum2;

GLUI_Listbox *obj_list;
GLUI_Rollout *obj_params;
GLUI_Spinner *spinner_dSize; 
GLUI_Spinner *spinner_radius; 
GLUI_Spinner *spinner_slices; 
GLUI_Spinner *spinner_stacks; 
GLUI_Spinner *spinner_height; 
GLUI_Spinner *spinner_base; 
GLUI_Spinner *spinner_dInnerRadius; 
GLUI_Spinner *spinner_dOuterRadius; 
GLUI_Spinner *spinner_nSides; 
GLUI_Spinner *spinner_nRings; 
GLUI_Spinner *spinner_num_levels; 
GLUI_Spinner *spinner_scale; 

GLUI_Rotation *view_rot;

void obj_param_control_cb( int control )
{
  spinner_dSize->disable();
  spinner_radius->disable();
  spinner_slices->disable();
  spinner_stacks->disable();
  spinner_height->disable();
  spinner_base->disable();
  spinner_dInnerRadius->disable();
  spinner_dOuterRadius->disable();
  spinner_nSides->disable();
  spinner_nRings->disable();
  spinner_num_levels->disable();
  spinner_scale->disable();

  switch( object_type ) {
    case 0: case 1:
      spinner_dSize->enable();
	  break;
    case 2:
      spinner_radius->enable(); spinner_slices->enable(); spinner_stacks->enable();
	  break;
    case 3:
      spinner_base->enable(); spinner_height->enable(); spinner_slices->enable(); spinner_stacks->enable();
	  break;
    case 4:
      spinner_radius->enable(); spinner_height->enable(); spinner_slices->enable(); spinner_stacks->enable();
	  break;
    case 5:
      spinner_dInnerRadius->enable(); spinner_dOuterRadius->enable(); spinner_nSides->enable(); spinner_nRings->enable();
	  break;
    case 11:
      spinner_num_levels->enable(); spinner_scale->enable();
	  break;
  }
}


void obj_control_cb( int control )
{
  // Control the object parameter rollout conforming the object type
  spinner_dSize->set_float_val(dSize); 
  spinner_radius->set_float_val(radius); 
  spinner_slices->set_int_val(slices); 
  spinner_stacks->set_int_val(stacks); 
  spinner_height->set_float_val(height); 
  spinner_base->set_float_val(base); 
  spinner_dInnerRadius->set_float_val(dInnerRadius); 
  spinner_dOuterRadius->set_float_val(dOuterRadius); 
  spinner_nSides->set_int_val(nSides); 
  spinner_nRings->set_int_val(nRings); 
  spinner_num_levels->set_int_val(num_levels); 
  spinner_scale->set_float_val(scale); 
}


static GLboolean stop_timer = GL_TRUE;


static GLboolean sum_x_z = GL_TRUE;
static GLboolean sum_x_y = GL_TRUE;

static void animateRotation( void )
{
  float temp;

  temp = 25.0 - eyex*eyex;
  if( temp < 0.0 ) temp = 0.0;

  // X-Z Animation
  if (animation_x_z)
  {
    if (sum_x_z)
    {
      eyex += 0.01;
      eyez = sqrt(temp);
      if (eyex > 5.0)
      {
        sum_x_z = !sum_x_z;
        eyex = 5.0;
      }
    }
    else
    {
      eyex -= 0.01;
      eyez = -sqrt(temp);
      if (eyex < -5.0)
      {
        sum_x_z = !sum_x_z;
        eyex = -5.0;
      }
    }
  }

  // X-Y Animation
  if (animation_x_y)
  {
    if (sum_x_y)
    {
      eyex += 0.01;
      eyey = sqrt(temp);
      if (eyex > 5)
      {
        sum_x_y = !sum_x_y;
        eyex = 5;
      }
    }
    else
    {
      eyex -= 0.01;
      eyey = -sqrt(temp);
      if (eyex < -5)
      {
        sum_x_y = !sum_x_y;
        eyex = -5;
      }
    }
  }
  spinner_eyex->set_float_val(eyex); 
  spinner_eyey->set_float_val(eyey);
  spinner_eyez->set_float_val(eyez);

  // Have to update the stored modelview matrix of the first view
  update_mv1();
}

void myGlutIdle( void )
{
  animateRotation();

  /* According to the GLUT specification, the current window is 
     undefined during an idle callback.  So we need to explicitly change
     it if necessary */
  if ( glutGetWindow() != main_window ) 
    glutSetWindow(main_window);  

  glutPostRedisplay();
}

void timerFunc(int value)
{
  /* fprintf(stderr,"\"timerFunc\" stopped=%d value=%d\n",
			stop_timer, value );	/**/
  if( stop_timer )  {
     /* fprintf(stderr,"Timer stopped. Returning...\n" );	/**/
    return;
  }
  animateRotation();

  /* According to the GLUT specification, the current window is 
     undefined during an idle callback.  So we need to explicitly change
     it if necessary */
  if ( glutGetWindow() != main_window ) 
    glutSetWindow(main_window);  

  glutPostRedisplay();
  GLUI_Master.set_glutTimerFunc(delay, timerFunc, value);
}


void control_cb( int control )
{
  if (control == RESET) {
    Reset(0);
    obj_control_cb( control );
    obj_param_control_cb( control );
  }  
  
  // Associate internal values to the interface
  spinner_centerx->set_float_val(centerx);  
  spinner_centery->set_float_val(centery);  
  spinner_centerz->set_float_val(centerz);  
  spinner_eyex->set_float_val(eyex); 
  spinner_eyey->set_float_val(eyey);
  spinner_eyez->set_float_val(eyez);
  spinner_upx->set_float_val(upx); 
  spinner_upy->set_float_val(upy);
  spinner_upz->set_float_val(upz);
  spinner_near->set_float_val(near_);
  spinner_far->set_float_val(far_); 
  spinner_left->set_float_val(left); 
  spinner_right->set_float_val(right); 
  spinner_bottom->set_float_val(bottom);
  spinner_top->set_float_val(top);
  spinner_fovy->set_float_val(fovy);
  spinner_aspect->set_float_val(aspect);
  checkbox_animation_xz->set_int_val(animation_x_z);  
  checkbox_animation_xy->set_int_val(animation_x_y);
  // Activate timer function if there is animation
  stop_timer = !animation_x_z && !animation_x_y;
  spinner_delay->set_int_val( (int)delay );
  if( !stop_timer )
    timerFunc(0);

  checkbox_ortho->set_int_val(orthographic);
  group_frustum->set_int_val(frustum);

  spinner_centerx2->set_float_val(centerx2);  
  spinner_centery2->set_float_val(centery2);  
  spinner_centerz2->set_float_val(centerz2);  
  spinner_eyex2->set_float_val(eyex2); 
  spinner_eyey2->set_float_val(eyey2);
  spinner_eyez2->set_float_val(eyez2);
  spinner_upx2->set_float_val(upx2); 
  spinner_upy2->set_float_val(upy2);
  spinner_upz2->set_float_val(upz2);
  spinner_near2->set_float_val(near_2);
  spinner_far2->set_float_val(far_2); 
  spinner_left2->set_float_val(left2); 
  spinner_right2->set_float_val(right2); 
  spinner_bottom2->set_float_val(bottom2);
  spinner_top2->set_float_val(top2);
  spinner_fovy2->set_float_val(fovy2);
  spinner_aspect2->set_float_val(aspect2);
  checkbox_ortho2->set_int_val(orthographic2);
  group_frustum2->set_int_val(frustum2);

  
  spinner_eyex->enable();
  spinner_eyey->enable();
  spinner_eyez->enable();
  // Control enable of X-Z animation checkboxes and sets its values
  if (animation_x_z)
  {
    spinner_eyex->disable();
    spinner_eyez->disable();
  }

  // Control enable of X-Y animation checkboxes and sets its values
  if (animation_x_y)
  {
    spinner_eyex->disable();
    spinner_eyey->disable();
  }
  
  if (orthographic)
    group_frustum->disable();
  else
    group_frustum->enable();
  if (frustum || orthographic)
  {
    spinner_fovy->disable();
    spinner_aspect->disable();
    spinner_left->enable(); 
    spinner_right->enable(); 
    spinner_bottom->enable(); 
    spinner_top->enable();
  }
  else
  {
    spinner_fovy->enable();
    spinner_aspect->enable();
    spinner_left->disable(); 
    spinner_right->disable(); 
    spinner_bottom->disable(); 
    spinner_top->disable();
  }

  if (orthographic2)
    group_frustum2->disable();
  else
    group_frustum2->enable();
  if (frustum2 || orthographic2)
  {
    spinner_fovy2->disable();
    spinner_aspect2->disable();
    spinner_left2->enable(); 
    spinner_right2->enable(); 
    spinner_bottom2->enable(); 
    spinner_top2->enable();
  }
  else
  {
    spinner_fovy2->enable();
    spinner_aspect2->enable();
    spinner_left2->disable(); 
    spinner_right2->disable(); 
    spinner_bottom2->disable(); 
    spinner_top2->disable();
  }
  obj_list->set_int_val( object_type );
  //fprintf(stderr,"Control CB: Stop Timer = %d\n", stop_timer );
}


void create_glui_interface()
{
  GLUI *glui = GLUI_Master.create_glui(
		  "OpenGL Viewing Volume Visualizer --- Thomas W. Rauber" );

  // Perspective controls of camera 1
  GLUI_Panel *obj_panel_cam1 = glui->add_panel( "Camera 1:" );



  // Controls of camera 1
  GLUI_Panel *obj_panel_cam_1 =
	glui->add_panel_to_panel( obj_panel_cam1,"Modelview - gluLookAt(...):");

  spinner_eyex = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Eye X:", GLUI_SPINNER_FLOAT,
							&eyex );

  spinner_eyey = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Eye Y:", GLUI_SPINNER_FLOAT,
							&eyey );

  spinner_eyez =
    glui->add_spinner_to_panel( obj_panel_cam_1, "Eye Z:", GLUI_SPINNER_FLOAT,
							&eyez );

  spinner_centerx = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Center X:",
						GLUI_SPINNER_FLOAT, &centerx );

  spinner_centery = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Center Y:",
						GLUI_SPINNER_FLOAT, &centery );

  spinner_centerz = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Center Z:",
						GLUI_SPINNER_FLOAT, &centerz );

  spinner_upx = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Up X:", GLUI_SPINNER_FLOAT,
							&upx );

  spinner_upy = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Up Y:", GLUI_SPINNER_FLOAT,
							&upy );

  spinner_upz = 
    glui->add_spinner_to_panel( obj_panel_cam_1, "Up Z:", GLUI_SPINNER_FLOAT,
							&upz );

  // Projection controls
  GLUI_Panel *obj_panel_volume1 = glui->add_panel_to_panel(
			obj_panel_cam1, "Projection:" );

  GLUI_Panel *obj_panel_perspectiva1 =
		glui->add_panel_to_panel ( obj_panel_volume1,
		"Projection Type - Utility:" );
  
  checkbox_ortho =  
	glui->add_checkbox_to_panel( obj_panel_perspectiva1,
		"Orthographic - glOrtho(...)", &orthographic, 1, control_cb );

  group_frustum =
    glui->add_radiogroup_to_panel(obj_panel_perspectiva1,&frustum,1,control_cb);
  radiogroup_perspective = 
    glui->add_radiobutton_to_group(group_frustum,
		"Perspective  -  glPerspective(...)");

  radiogroup_frustum = 
    glui->add_radiobutton_to_group(group_frustum,
		"Perspective  -  glFrustum(...)");

  GLUI_Panel *obj_panel_param1 =
		glui->add_panel_to_panel ( obj_panel_volume1,
		"Utility Parameters:" );
  
  spinner_near = 
    glui->add_spinner_to_panel( obj_panel_param1, "Near:", GLUI_SPINNER_FLOAT,
					&near_ );

  spinner_far = 
    glui->add_spinner_to_panel( obj_panel_param1, "Far:", GLUI_SPINNER_FLOAT,
					&far_ );

  spinner_left = 
    glui->add_spinner_to_panel( obj_panel_param1, "Left:", GLUI_SPINNER_FLOAT,
							&left );

  spinner_right = 
    glui->add_spinner_to_panel( obj_panel_param1, "Right:", GLUI_SPINNER_FLOAT,
							&right );

  spinner_bottom = 
    glui->add_spinner_to_panel( obj_panel_param1, "Bottom:",GLUI_SPINNER_FLOAT,
							&bottom );

  spinner_top = 
    glui->add_spinner_to_panel( obj_panel_param1, "Top:", GLUI_SPINNER_FLOAT,
							&top );

  spinner_fovy = 
    glui->add_spinner_to_panel( obj_panel_param1, "Fovy:", GLUI_SPINNER_FLOAT,
							&fovy );

  spinner_aspect = 
    glui->add_spinner_to_panel( obj_panel_param1, "Aspect:",GLUI_SPINNER_FLOAT,
							&aspect );

  
  // Perspective controls of camera 2
  glui->add_column(false);
  GLUI_Panel *obj_panel_cam2 = glui->add_panel( "Camera 2:" );

    
  // Controls of camera 2
  GLUI_Panel *obj_panel_cam_2 = glui->add_panel_to_panel( obj_panel_cam2,
					"Modelview - gluLookAt(...):" );

  spinner_eyex2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Eye X:", GLUI_SPINNER_FLOAT,
					&eyex2 );

  spinner_eyey2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Eye Y:", GLUI_SPINNER_FLOAT,
					&eyey2 );

  spinner_eyez2 =
    glui->add_spinner_to_panel( obj_panel_cam_2, "Eye Z:", GLUI_SPINNER_FLOAT,
					&eyez2 );

  spinner_centerx2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Center X:",
			GLUI_SPINNER_FLOAT, &centerx2 );

  spinner_centery2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Center Y:",
			GLUI_SPINNER_FLOAT, &centery2 );

  spinner_centerz2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Center Z:",
			GLUI_SPINNER_FLOAT, &centerz2 );

  spinner_upx2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Up X:", GLUI_SPINNER_FLOAT,
					&upx2 );

  spinner_upy2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Up Y:", GLUI_SPINNER_FLOAT,
					&upy2 );

  spinner_upz2 = 
    glui->add_spinner_to_panel( obj_panel_cam_2, "Up Z:", GLUI_SPINNER_FLOAT,
					&upz2 );

  // Projection controls
  GLUI_Panel *obj_panel_volume2 = glui->add_panel_to_panel( obj_panel_cam2,
				"Projection:" );

  GLUI_Panel *obj_panel_perspectiva2 = glui->add_panel_to_panel(
		obj_panel_volume2, "Projection Type - Utility:" );
  
  checkbox_ortho2 = 
    glui->add_checkbox_to_panel( obj_panel_perspectiva2,
		"Orthographic - glOrtho(...)", &orthographic2, 1, control_cb );

  group_frustum2 =
    glui->add_radiogroup_to_panel(obj_panel_perspectiva2, &frustum2,1,
			control_cb );
  radiogroup_perspective2 = 
    glui->add_radiobutton_to_group(group_frustum2,
		"Perspective  -  glPerspective(...)");

  radiogroup_frustum2 = 
    glui->add_radiobutton_to_group(group_frustum2,
		"Perspective  -  glFrustum(...)");

  GLUI_Panel *obj_panel_param2 =
		glui->add_panel_to_panel ( obj_panel_volume2,
		"Utility Parameters:" );
  
  spinner_near2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Near:", GLUI_SPINNER_FLOAT,
					&near_2 );

  spinner_far2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Far:", GLUI_SPINNER_FLOAT,
					&far_2 );

  spinner_left2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Left:", GLUI_SPINNER_FLOAT,
					&left2 );

  spinner_right2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Right:", GLUI_SPINNER_FLOAT,
					&right2 );

  spinner_bottom2 = 
  glui->add_spinner_to_panel( obj_panel_param2, "Bottom:",
			GLUI_SPINNER_FLOAT, &bottom2 );

  spinner_top2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Top:", GLUI_SPINNER_FLOAT,
					&top2 );

  spinner_fovy2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Fovy:", GLUI_SPINNER_FLOAT,
					&fovy2 );

  spinner_aspect2 = 
    glui->add_spinner_to_panel( obj_panel_param2, "Aspect:",
			GLUI_SPINNER_FLOAT, &aspect2 );

  // Animations
  glui->add_column(false);
  GLUI_Panel *obj_panel_animation_1 = glui->add_panel( "Rotation Animation:" );
  // X-Z animation option
  checkbox_animation_xz =
    glui->add_checkbox_to_panel( obj_panel_animation_1, "Animation X-Z",
					&animation_x_z, 1, control_cb );
  // X-Y animation option
  checkbox_animation_xy =
    glui->add_checkbox_to_panel( obj_panel_animation_1, "Animation X-Y",
					&animation_x_y, 1, control_cb );

  spinner_delay = glui->add_spinner_to_panel( obj_panel_animation_1,
		  "Delay (msec)", GLUI_SPINNER_INT, &delay, 1, control_cb );
  spinner_delay->set_int_limits( 0, 1000, GLUI_LIMIT_CLAMP );
  //--------------------------------------------------------------------  
  // VV presentation controls
  GLUI_Panel *obj_panel_vv_1 = glui->add_panel( "Viewing Volume:" );

  // Wireframe option
  glui->add_checkbox_to_panel( obj_panel_vv_1, "Wireframe", &vvwireframe );

  //--------------------------------------------------------------------  

  
  //--------------------------------------------------------------------  
  // Object controls
  GLUI_Panel *obj_panel_objeto_1 = glui->add_panel( "Object Control:" );

  // Wireframe option
  glui->add_checkbox_to_panel( obj_panel_objeto_1, "Wireframe", &wireframe );

  /**** Adiciona ao ListBox ****/
  //Escolha do tipo de objeto
  glui->add_statictext( "" );
  obj_list = glui->add_listbox_to_panel( obj_panel_objeto_1,
		"GLUT Object:", &object_type, 1, obj_param_control_cb );
  obj_list->add_item( 0, "Tea Pot" );
  obj_list->add_item( 1, "Cube" );
  obj_list->add_item( 2, "Sphere" );
  obj_list->add_item( 3, "Cone" );
  obj_list->add_item( 4, "Cylinder" );
  obj_list->add_item( 5, "Torus" );
  obj_list->add_item( 6, "Dodecahedron" );
  obj_list->add_item( 7, "Octahedron" );
  obj_list->add_item( 8, "Tetrahedron" );
  obj_list->add_item( 9, "Icosahedron" );
  obj_list->add_item( 10, "Rhombic Dodecahedron" );
  obj_list->add_item( 11, "Sierpinski Sponge" );
  glui->add_statictext( "" );

  // Rollout for object parameters
  obj_params = glui->add_rollout_to_panel( obj_panel_objeto_1,
		 "Object Parameters", false );
  spinner_dSize = glui->add_spinner_to_panel( obj_params, "Size",
			GLUI_SPINNER_FLOAT, &dSize, 1, obj_control_cb );
  spinner_dSize->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );
  spinner_radius = glui->add_spinner_to_panel( obj_params, "Radius",
			GLUI_SPINNER_FLOAT, &radius, 1, obj_control_cb );
  spinner_radius->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );
  spinner_slices = glui->add_spinner_to_panel( obj_params, "Slices",
			GLUI_SPINNER_INT, &slices, 1, obj_control_cb );
  spinner_slices->set_int_limits( 0, 100, GLUI_LIMIT_CLAMP );
  spinner_stacks = glui->add_spinner_to_panel( obj_params, "Stacks",
			GLUI_SPINNER_INT, &stacks, 1, obj_control_cb );
  spinner_stacks->set_int_limits( 0, 100, GLUI_LIMIT_CLAMP );
  spinner_height = glui->add_spinner_to_panel( obj_params, "Height",
			GLUI_SPINNER_FLOAT, &height, 1, obj_control_cb );
  spinner_height->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );
  spinner_base = glui->add_spinner_to_panel( obj_params, "Base",
			GLUI_SPINNER_FLOAT, &base, 1, obj_control_cb );
  spinner_base->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );
  glui->add_column_to_panel( obj_params, true );
  spinner_dInnerRadius = glui->add_spinner_to_panel( obj_params, "Inner Radius",
			GLUI_SPINNER_FLOAT, &dInnerRadius, 1, obj_control_cb );
  spinner_dInnerRadius->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );
  spinner_dOuterRadius = glui->add_spinner_to_panel( obj_params, "Outer Radius",
			GLUI_SPINNER_FLOAT, &dOuterRadius, 1, obj_control_cb );
  spinner_dOuterRadius->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );
  spinner_nSides = glui->add_spinner_to_panel( obj_params, "Num. Sides",
			GLUI_SPINNER_INT, &nSides, 1, obj_control_cb );
  spinner_nSides->set_int_limits( 0, 100, GLUI_LIMIT_CLAMP );
  spinner_nRings = glui->add_spinner_to_panel( obj_params, "Num. Rings",
			GLUI_SPINNER_INT, &nRings, 1, obj_control_cb );
  spinner_nRings->set_int_limits( 0, 100, GLUI_LIMIT_CLAMP );
  spinner_num_levels = glui->add_spinner_to_panel( obj_params, "Num. Levels",
			GLUI_SPINNER_INT, &num_levels, 1, obj_control_cb );
  spinner_num_levels->set_int_limits( 0, 10, GLUI_LIMIT_CLAMP );
  spinner_scale = glui->add_spinner_to_panel( obj_params, "Scale",
			GLUI_SPINNER_FLOAT, &scale, 1, obj_control_cb );
  spinner_scale->set_float_limits( 0.0, 100.0, GLUI_LIMIT_CLAMP );

  //
  // Rotate object
  view_rot = glui->add_rotation_to_panel( obj_panel_objeto_1,
		"Rotate Object", view_rotate );
  //view_rot->reset();
  view_rot->set_spin( 1.0 );
  //--------------------------------------------------------------------  


  // Generate modelview and projection matrices
  glui->add_button( "Matrix Exhibition", 0,
			(GLUI_Update_CB)show_modelview_and_projection_matrices);
  // Generate C code which specifies the modelview and projection
  glui->add_button( "Code Generation", 0,
				(GLUI_Update_CB)gen_c_code_viewing_and_proj );
  // Reset
  glui->add_button( "Reset", RESET, (GLUI_Update_CB)control_cb );
  // Quit program
  glui->add_button( "Quit", 0, (GLUI_Update_CB)exit );

  glui->set_main_gfx_window( main_window );

  /**** We register the idle callback with GLUI, *not* with GLUT ****/
  // HAS TO BE SET ! If not the rotation control does not work properly
  GLUI_Master.set_glutIdleFunc( NULL );
  //GLUI_Master.set_glutIdleFunc( myGlutIdle );
  GLUI_Master.set_glutTimerFunc(0, timerFunc, 0);
  
  // Reset control
  control_cb(RESET);
}


#endif	// FEEDBACK
